﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private txtInput As TextArea
	Private btnSend As Button
	Private txtOutput As TextArea
	Private cModel As ComboBox
	Private cTemplate As ComboBox
	Private TemplatesMap As Map
	Private TemplateString As String
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub


Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
		
	Main.Ollama.Initialize("Ollama", "http://localhost:11434/")
	Main.Ollama.Verbose = True
	Main.Ollama.RequestTimeoutSeconds = 180
	Log("Ollama server online: " & Main.Ollama.Ping)
	If Main.Ollama.Ping Then
		GetModels
	Else
		txtOutput.Text = "Ollama server is OFFLINE."
	End If
	CreateTemplatesMap
End Sub


Private Sub GetModels
	cModel.Items.Clear
	For Each Model As Pnd_Model In Main.Ollama.ListModels
		cModel.Items.Add(Model.Model)
	Next
	If cModel.Items.Size < 1 Then
		xui.MsgboxAsync("You don't have any model to use.", "Info")
	End If		
End Sub


Private Sub btnSend_Click
	btnSend.Enabled = False
	GetTemplateFromMap
	Dim outputBuilder As StringBuilder
	outputBuilder.Initialize
	Dim POLL_INTERVAL As Int = 100 ' milliseconds
	Dim result As Pnd_OllamaAsyncResult = Main.Ollama.GenerateAsync(cModel.Value, TemplateString, False)
	Do While True
		Dim token As String = result.StreamPool
		outputBuilder.Append(token.Replace("\n", CRLF))
		txtOutput.Text = outputBuilder.ToString()
		txtOutput.SetSelection(txtOutput.Text.Length, txtOutput.Text.Length)
		If result.IsAlive = False Then
			outputBuilder.Append(CRLF & CRLF)
			txtOutput.Text = outputBuilder.ToString()
			txtOutput.SetSelection(txtOutput.Text.Length, txtOutput.Text.Length)
			Exit
		End If
		Sleep(POLL_INTERVAL)
	Loop
	btnSend.Enabled = True
End Sub


Private Sub CreateTemplatesMap
	TemplatesMap.Initialize
	TemplatesMap.Put("Raw Text", "{B4XCODE}")
	
	TemplatesMap.Put("Find Bugs", $"Your task is to find potential bugs in the given code snippet.
Carefully examine the code for potential bugs, logical errors, or common programming mistakes. Consider issues such as:
Syntax errors
Off-by-one errors
Null pointer exceptions
Memory leaks
Infinite loops
Incorrect logic
Unhandled exceptions
Provide a concise list of potential bugs you've identified. If you don't find any bugs, state that the code appears to be bug-free based on your analysis.
Here's the code to analyze writen with B4X language:
{B4XCODE}"$)
	
	TemplatesMap.Put("Refactor", $"Your task is to improve the code's readability, efficiency, and maintainability without changing its functionality. Follow these steps:
Analyze the following selected code:
Identify areas for improvement, such as:
Simplifying complex logic
Removing redundant code
Improving naming conventions
Enhancing code structure
Refactor the code, keeping these guidelines in mind:
Maintain the original functionality
Follow best practices for the programming language used
Prioritize readability and maintainability
Be concise in your explanation, focusing on the most important improvements made.
Here's the code to refactor writen with B4X language:
{B4XCODE}"$)

	TemplatesMap.Put("Optimize", $"Your task is to improve the code's efficiency, readability, and adherence to best practices without changing its core functionality.
Analyze the code and suggest optimizations that could improve its performance, readability, or maintainability. Focus on:
Reducing time complexity
Improving space efficiency
Enhancing code readability
Applying relevant design patterns or coding best practices
Provide your optimized version of the code, along with brief comments explaining the key changes and their benefits.
Keep your response concise and focused on the most impactful optimizations.
Here's the code to optimize writen with B4X language:
{B4XCODE}"$)

	TemplatesMap.Put("Explain", $"Your task is to provide a clear, concise explanation of what this code does. Focus on the main functionality and purpose of the code, avoiding unnecessary details. Explain any complex logic or algorithms if present.
Provide your explanation in a few sentences, using simple language that a junior programmer could understand. If there are any notable best practices or potential improvements, briefly mention them at the end.
Here's the code to analyze writen with B4X language:
{B4XCODE}"$)
	
	For Each Key As String In TemplatesMap.Keys
		cTemplate.Items.Add(Key)
	Next	
	cTemplate.SelectedIndex = 0
End Sub


Private Sub GetTemplateFromMap
	TemplateString = TemplatesMap.Get(cTemplate.Value)
	TemplateString = TemplateString.Replace("{B4XCODE}", txtInput.Text)
End Sub

